#!/bin/sh

# Setup script for intel driver
# FIXME: this should use libsax-perl, but libsax seems to be mangling
# xorg.conf (qv 184540)

case "$*" in
-n)
	make_changes=0
	;;
*)
	make_changes=1
	;;
esac

function check_module {
    module="$1"

    perl -n -e \
	'if (/^Section "Module"/../^EndSection/) {
		if (/^\s*Load\s+"'"$module"'"/) {
			exit 1;
		}
	}' /etc/X11/xorg.conf && return 1
    return 0
}

function add_module {
    module="$1"

    perl -ni -e \
	'if (/^Section "Module"/../^EndSection/) {
		if (/^\s*Load\s+"'"$module"'"/) {
			$set = 1;
		} elsif (/^EndSection/ && !$set) {
			print "  Load         \"'"$module"'\"\n";
			print;
		} else {
			print;
		}
	} else {
		print;
	}' /etc/X11/xorg.conf
}

if [ $make_changes = 1 ]; then
    if ! add_module "dri"; then
	exit 1
    fi
else
    if ! check_module "dri"; then
	exit 1
    fi
fi

exit 0
